<?php
//
// actionItem.php
//
// Module for processing entries from MySQL database tables
//
// CopyRight (c) 2003-2006 Xiaohui Li
//
session_start();

require_once 'locale.php';
include_once 'database.php';
include_once 'sharedData.php';

global $PRODUCT;
global $STUDY_STATUS_READ;
$database = $_SESSION['authenticatedDatabase'];
$username = $_SESSION['authenticatedUser'];
$password = $_SESSION['authenticatedPassword'];
$dbcon = new MyDatabase($hostname, $database, $username, $password);
$action = $_POST['action'];
$option = $_POST['option'];
$entry = $_POST['entry'];
if (!isset($entry) || count($entry) == 0) {
    print "<h3><font color=red>" . pacsone_gettext("No item has been selected.") . "</font></h3>\n";
    exit();
}
$url = "home.php";
if (!strcasecmp($action, "Tag") || !strcasecmp($action, "Un-Tag")) {
    if (isset($option) && isset($entry) && !strcasecmp($option, "Image")) {
        $value = strcasecmp($action, "Tag")? 0 : 1;
        foreach ($entry as $uid) {
            $query = "update image set tagged=$value where uid='$uid';";
            $dbcon->query($query);
        }
        // back to the Image Thumbnail page
        $result = $dbcon->query("select seriesuid from image where uid='" . $entry[0] . "';");
        $row = $dbcon->fetch_row($result);
        $seriesUid = $row[0];
        $result = $dbcon->query("select studyuid from series where uid='$seriesUid';");
        $row = $dbcon->fetch_row($result);
        $studyUid = $row[0];
        $patientId = $dbcon->getPatientIdByStudyUid($studyUid);
        $url = "image.php?patientId=" . urlencode($patientId) . "&studyId=$studyUid&seriesId=$seriesUid";
        header("Location: $url");
        exit;
    }
}
if (strcasecmp($action, "Delete") == 0 && isset($option)) {
    // disable PHP timeout
    set_time_limit(0);
    // log activity to system journal
    foreach ($entry as $uid) {
        $uid = urldecode($uid);
        $dbcon->logJournal($username, $action, $option, $uid);
    }
    if (strcasecmp($option, "Image") == 0) {
	    $url = deleteImages($entry);
    }
    else if (strcasecmp($option, "Series") == 0) {
	    $url = deleteSeries($entry);
    }
    else if (strcasecmp($option, "Study") == 0) {
	    $url = deleteStudies($entry);
    }
    else if (strcasecmp($option, "Patient") == 0) {
	    $url = deletePatients($entry);
    }
    else if (strcasecmp($option, "Worklist") == 0) {
	    $url = deleteWorklists($entry);
    }
    // go back to the page
    header("Location: " . $url);
}
if (strcasecmp($action, "Forward") == 0 && isset($option)) {
	// display destination AE form
	print "<html>\n";
	print "<head><title>$PRODUCT - ";
    print pacsone_gettext("Forwarding ");
    print pacsone_gettext($option);
    print "</title></head>\n";
	print "<body>\n";
	require_once 'header.php';
	$result = $dbcon->query("select title,ipaddr from applentity where port is not NULL;");
	if ($dbcon->num_rows($result) == 0) {
		print "<h3><font color=red>";
        print pacsone_gettext("There is no valid AE to forward to.");
        print "</font></h3>";
	}
	else {
        $remote = $_SERVER["REMOTE_ADDR"];
        print "<form method='POST' action='forward.php'>\n";
		print "<table>\n";
		print "<tr><td>";
        print pacsone_gettext("Forward the following ");
        print pacsone_gettext($option);
        print ":</td></tr>\n";
		print "<tr><td><br></td></tr>\n";
		foreach ($entry as $uid) {
            if (strcasecmp($option, "Patient") == 0)
                $uid = urldecode($uid);
			print "<tr><td>$uid</td></tr>\n";
		}
		print "<tr><td><br></td></tr>\n";
		print "<tr><td>";
        print pacsone_gettext("Please select which Application Entity to forward to:");
        print "</td>";
		print "<td><select name='aetitle'>";
		while ($row = $dbcon->fetch_row($result)) {
            if (strcmp($row[1], $remote) == 0)
			    print "<option selected>$row[0]";
            else
			    print "<option>$row[0]";
		}
		print "</select></td>\n";
        print "</table>\n";
		print "<input type=hidden name='option' value=$option>\n";
		foreach ($entry as $uid) {
			print "<input type=hidden name='entry[]' value='$uid'>\n";
		}
        print "<p><input type='submit' value='" . pacsone_gettext("Forward") . "'>\n";
        print "</form>\n";
	}
	require_once 'footer.php';
	print "</body>\n";
	print "</html>\n";
}
if ((!strcasecmp($action, "Show") || !strcasecmp($action, "Download")) && isset($option)) {
    if (strcasecmp($action, "Show") == 0) {
	    include_once 'applet.php';
    } else if (strcasecmp($action, "Download") == 0) {
	    include_once 'download.php';
        $filename = count($entry) . "-" . $option;
    }

	$uids = array();
    if (strcasecmp($option, "Image") == 0) {
	    foreach ($entry as $uid) {
            // log activity to system journal
            $dbcon->logJournal($username, $action, $option, $uid);
		    $uids[] = $uid;
	    }
    } else if (strcasecmp($option, "Series") == 0) {
	    foreach ($entry as $seriesUid) {
            // log activity to system journal
            $dbcon->logJournal($username, $action, $option, $seriesUid);
            $result = $dbcon->query("select uid from image where seriesuid='$seriesUid' order by instance ASC;");
            while ($row = $dbcon->fetch_row($result))
                $uids[] = $row[0];
	    }
    } else if (strcasecmp($option, "Study") == 0) {
		foreach ($entry as $uid)
		{
            // log activity to system journal
            $dbcon->logJournal($username, $action, $option, $uid);
            //modification!
            //do not... mark study as 'reviewed'
            //$dbcon->query("UPDATE study SET reviewed='$username' WHERE uid='$uid'");
            //$dbcon->query("UPDATE worklist SET status=$STUDY_STATUS_READ WHERE studyuid='$uid';");
            
            // $uid contains a STUDY Instance UID
            $resultSeries = $dbcon->query("SELECT uid FROM series where studyuid='$uid' ORDER BY number ASC;");
            while ($rowSeries = $dbcon->fetch_array($resultSeries))
            {
                $seriesUid = $rowSeries[0];
                $result = $dbcon->query("SELECT uid FROM image where seriesuid='$seriesUid' ORDER BY instance ASC;");
                while ($row = $dbcon->fetch_array($result))
                    $uids[] = $row[0];
            }
        }
    } else if (strcasecmp($option, "Patient") == 0) {
        $studies = array();
		foreach ($entry as $pid)
		{
            $pid = urldecode($pid);
            // log activity to system journal
            $dbcon->logJournal($username, $action, $option, $pid);
            $result = $dbcon->query("select uid from study where patientid='$pid';");
            while ($studyRow = $dbcon->fetch_row($result))
                $studies[] = $studyRow[0];
        }
        foreach ($studies as $uid)
        {
            //modification!
            //do not... mark study as 'reviewed'
            //$dbcon->query("UPDATE study SET reviewed='$username' WHERE uid='$uid'");
            
            // $uid contains a STUDY Instance UID
            $resultSeries = $dbcon->query("SELECT uid FROM series where studyuid='$uid' ORDER BY number ASC;");
            while ($rowSeries = $dbcon->fetch_array($resultSeries))
            {
                $seriesUid = $rowSeries[0];
                $result = $dbcon->query("SELECT uid FROM image where seriesuid='$seriesUid' ORDER BY instance ASC;");
                while ($row = $dbcon->fetch_array($result))
                    $uids[] = $row[0];
            }
        }
    }
    if (strcasecmp($action, "Show") == 0) {
        if (count($uids))
	        appletViewer($uids);
        else {
	        print "<html>\n";
	        print "<head><title>$PRODUCT - ";
            print pacsone_gettext("Show Images");
            print "</title></head>\n";
	        print "<body leftmargin=\"0\" topmargin=\"0\" bgcolor=\"#cccccc\">\n";
	        require_once 'header.php';
            print "<p>" . pacsone_gettext("No image to display.") . "<br>";
	        require_once 'footer.php';
	        print "</body>\n";
	        print "</html>\n";
        }
    } else if (strcasecmp($action, "Download") == 0) {
        $files = array();
        foreach ($uids as $uid) {
            $result = $dbcon->query("select path from image where uid='$uid';");
            if ($row = $dbcon->fetch_row($result)) {
                $path = $row[0];
                if (file_exists($path)) {
                    $files[$uid] = $path;
                }
            }
        }
        zipFiles($files, $filename);
    }
}
if (strcasecmp($action, "Print") == 0 && isset($option)) {
	// display destination AE form
	print "<html>\n";
	print "<head><title>$PRODUCT - ";
    print pacsone_gettext("Printing ");
    print pacsone_gettext($option);
    print "</title></head>\n";
	print "<body>\n";
	require_once 'header.php';
	$result = $dbcon->query("select title from applentity where port is not NULL and printScp=1;");
	if ($dbcon->num_rows($result) == 0) {
		print "<h3><font color=red>";
        print pacsone_gettext("There is no Dicom printer configured.");
        print "</font></h3>";
	}
	else {
        print "<form method='POST' action='printer.php'>\n";
        print "<table width=100% cellpadding=0 cellspacing=0 border=0>\n";
        print "<tr><td>";
        print pacsone_gettext("Print the following ");
        print pacsone_gettext($option);
        print ":</td></tr>\n";
        print "<tr><td><br></td></tr>\n";
        foreach ($entry as $uid) {
            if (strcasecmp($option, "Patient") == 0)
                $uid = urldecode($uid);
            print "<tr><td>$uid</td></tr>\n";
        }
        print "<tr><td><br></td></tr>\n";
        print "<tr><td>";
        print pacsone_gettext("Please select which Dicom Printer to print to: ");
        print "<select name='printer'>";
        while ($row = $dbcon->fetch_row($result)) {
            print "<option>$row[0]";
        }
        print "</select></td>\n";
        print "</table>\n";
        print "<input type=hidden name='option' value=$option>\n";
        foreach ($entry as $uid) {
            print "<input type=hidden name='entry[]' value='$uid'>\n";
        }
        print "<p><input type='submit' value='" . pacsone_gettext("Print") . "'>\n";
        print "</form>\n";
	}
	require_once 'footer.php';
	print "</body>\n";
	print "</html>\n";
}
if (strcasecmp($action, "Export") == 0 && isset($option)) {
	// display destination AE form
	print "<html>\n";
	print "<head><title>$PRODUCT - ";
    print pacsone_gettext("Exporting ");
    print pacsone_gettext($option);
    print "</title></head>\n";
	print "<body>\n";
	require_once 'header.php';
	include_once 'display.php';

	print "<table>\n";
	print "<tr><td>";
    print pacsone_gettext("Export the following ");
    print pacsone_gettext($option);
    print ":</td></tr>\n";
	print "<tr><td><br></td></tr>\n";
	print "<tr><td>";
    displayExportItem($option, $entry);
	print "</tr></td>";
	print "<tr><td><br></td></tr>\n";
	print "<tr><td>";
    $directory = dirname($_SERVER['SCRIPT_FILENAME']);
    $directory = dirname($directory);
    // check if user has defined a preferred Export dir
    $preferred = "";
    $result = $dbcon->query("select exportdir from privilege where user='$username';");
    if ($result && $dbcon->num_rows($result)) {
        $row = $dbcon->fetch_row($result);
        if (strlen($row[0]) && file_exists($row[0]))
            $preferred = $row[0];
    }
    $exportdir = strlen($preferred)? $preferred : ($directory . "/export/");
    print "<form method=POST action='exportStudy.php'>\n";
    displayExportForm($option, $exportdir);
    $title = pacsone_gettext("Export ") . ucfirst($option);
    print "<br><input type=submit value='$title' title='$title'><br>";
    print "<input type=hidden name='option' value=$option>\n";
    foreach ($entry as $uid) {
        print "<input type=hidden name='entry[]' value='$uid'>\n";
    }
    print "</form>\n";
    print "</td></tr>\n";
    print "</table>\n";
	require_once 'footer.php';
	print "</body>\n";
	print "</html>\n";
}
if (stristr($action, "Mark Study") && strcasecmp($option, "Study") == 0) {
    foreach ($entry as $uid) {
        $dbcon->query("UPDATE study SET reviewed='$username' WHERE uid='$uid';");
        $dbcon->query("UPDATE worklist SET status=$STUDY_STATUS_READ WHERE studyuid='$uid';");
        // log activity to system journal
        $dbcon->logJournal($username, $action, $option, $uid);
    }
    // back to the original page
    $url = $_SERVER["HTTP_REFERER"];
    if (stristr($url, "study.php")) {
        $studyUid = $entry[0];
        $patientId = $dbcon->getPatientIdByStudyUid($studyUid);
        $url = "study.php?patientId=" . urlencode($patientId);
    }
    header("Location: $url");
    exit;
}

function deleteImages($entry)
{
    if (count($entry) == 0)
        return "home.php";
    global $dbcon;
	$url = "image.php";
	$ok = array();
	$errors = array();
	// find patient, study and series ids
	$result = $dbcon->query("select seriesuid from image where uid='$entry[0]';");
	$row = $dbcon->fetch_row($result);
	$seriesid = $row[0];
	$result = $dbcon->query("select studyuid from series where uid='$seriesid';");
	$row = $dbcon->fetch_row($result);
	$studyid = $row[0];
	$result = $dbcon->query("select patientid from study where uid='$studyid';");
	$row = $dbcon->fetch_row($result);
	$patientid = $row[0];
	// update the URL for refreshing
	$url .= "?patientId=$patientid&studyId=$studyid&seriesId=$seriesid";
    $dir = strtr(getcwd(), "\\", "/");
    // append '/' at the end if not so already
    if (strcmp(substr($dir, strlen($dir)-1, 1), "/"))
    	$dir .= "/";
	foreach ($entry as $value) {
		$junks = array(
        	($dir . "/thumbnails/$value.jpg"),
        	($dir . "/thumbnails/$value.gif"),
        	($dir . "/images/$value.jpg"),
        	($dir . "/images/$value.gif"),
        	($dir . "/images/temp.$value.jpg"),
        	($dir . "/images/temp.$value.gif"),
		);
        // delete any related attachments
        $result = $dbcon->query("select path from attachment where uid='$value';");
        if ($result) {
            while ($row = $dbcon->fetch_row($result))
                unlink($row[0]);
        }
        $dbcon->query("delete from attachment where uid='$value';");
        // delete image notes
        $dbcon->query("delete from imagenotes where uid='$value';");
        // remove physical storage file
        $query = "select * from image where uid='$value';";
        $result = $dbcon->query($query);
        if ($dbcon->num_rows($result) == 1) {
            $row = $dbcon->fetch_array($result);
            if (file_exists( $row['path'] ))
                unlink( $row['path'] );
            // remove post-receive compressed files
            $junks[] = $row['path'] . ".ls";
            $junks[] = $row['path'] . ".ly";
            $junks[] = $row['path'] . ".rle";
        }
		$query = "delete from image where uid='$value';";
		if (!$dbcon->query($query)) {
			$errors[$value] = "MySQL Error " . $dbcon->getErrno() . ": " . $dbcon->getError();
		}
		else
			$ok[] = $value;
		// remove any thumbnail and cached ImageMagick files
		foreach ($junks as $file) {
			if (file_exists($file))
				unlink($file);
		}
		// delete any derived tables
		$query = "delete from conceptname where uid='$value';";
		$dbcon->query($query);
	}
	return $url;
}

function deleteSeries($entry)
{
    if (count($entry) == 0)
        return "home.php";
    global $dbcon;
	$url = "series.php";
	$ok = array();
	$errors = array();
	// find study ID and patient ID
	$result = $dbcon->query("select studyuid from series where uid='$entry[0]';");
    if (!$result || ($dbcon->num_rows($result) == 0))
        return "home.php";
	$row = $dbcon->fetch_row($result);
	$studyid = $row[0];
	$result = $dbcon->query("select patientid from study where uid='$studyid';");
	$row = $dbcon->fetch_row($result);
	$patientid = $row[0];
	// update URL for refreshing
	$url .= "?patientId=$patientid&studyId=$studyid";
	foreach ($entry as $value) {
        // find all related image rows
        $images = array();
        $query = "select * from image where seriesuid='$value';";
        $result = $dbcon->query($query);
        while ($row = $dbcon->fetch_array($result)) {
            $images[] = $row['uid'];
        }
        // delete all related image rows
        deleteImages($images);
		$query = "delete from series where uid='$value';";
		if (!$dbcon->query($query)) {
			$errors[$value] = "MySQL Error " . $dbcon->getErrno() . ": " . $dbcon->getError();
		}
		else
			$ok[] = $value;
	}
	return $url;
}

function deleteStudies($entry)
{
    if (count($entry) == 0)
        return "home.php";
    global $dbcon;
	$url = "study.php";
	$ok = array();
	$errors = array();
	// find the patient id
	$result = $dbcon->query("select patientid from study where uid='$entry[0]';");
    if (!$result || ($dbcon->num_rows($result) == 0))
        return "home.php";
	$row = $dbcon->fetch_row($result);
	$patientid = $row[0];
	// update the URL for refreshing
	$url .= "?patientId=$patientid";
	foreach ($entry as $value) {
        // delete any related attachments
        $result = $dbcon->query("select path from attachment where uid='$value';");
        if ($result) {
            while ($row = $dbcon->fetch_row($result)) {
                if (file_exists($row[0]))
                    unlink($row[0]);
            }
        }
        $dbcon->query("delete from attachment where uid='$value';");
        // delete study notes
        $dbcon->query("delete from studynotes where uid='$value';");
        // find all related series rows
        $series = array();
        $query = "select * from series where studyuid='$value';";
        $result = $dbcon->query($query);
        while ($row = $dbcon->fetch_array($result)) {
            $series[] = $row['uid'];
        }
        // delete all related series rows
        deleteSeries($series);
		$query = "delete from study where uid='$value';";
		if (!$dbcon->query($query)) {
			$errors[$value] = "MySQL Error " . $dbcon->getErrno() . ": " . $dbcon->getError();
		}
		else
			$ok[] = $value;
	}
	return $url;
}

function deletePatients($entry)
{
    global $dbcon;
	$url = "browse.php";
	$ok = array();
	$errors = array();
	foreach ($entry as $value) {
        $value = addslashes(urldecode($value));
        // find all related study rows
        $studies = array();
        $query = "select * from study where patientid='$value';";
        $result = $dbcon->query($query);
        while ($row = $dbcon->fetch_array($result)) {
            $studies[] = $row['uid'];
        }
        // delete all related study rows
        deleteStudies($studies);
		$query = "delete from patient where origid='$value';";
		if (!$dbcon->query($query)) {
			$errors[$value] = "MySQL Error " . $dbcon->getErrno() . ": " . $dbcon->getError();
		}
		else
			$ok[] = $value;
	}
	return $url;
}

function deleteWorklists($entry)
{
    global $dbcon;
	$url = "worklist.php";
	$ok = array();
	$errors = array();
    $tables = array(
        "worklist", "scheduledps", "requestedprocedure", "protocolcode", "procedurecode",
        "referencedpps", "referencedstudy", "referencedpatient", "referencedvisit",
    );
	foreach ($entry as $uid) {
        $success = true;
        // delete all related table rows
        foreach ($tables as $table) {
		    $query = "delete from $table where studyuid='$uid';";
		    if (!$dbcon->query($query)) {
			    $errors[$uid] = "MySQL Error deleting '$table' table rows: " . $dbcon->getErrno() . ": " . $dbcon->getError();
                print "<p><h3><font color=red>";
                print pacsone_gettext("Fatal Error: ") . $errors[$uid] . "</font></h3>\n";
                exit();
		    }
        }
        if ($success)
            $ok[] = $uid;
	}
    return $url;
}

?>